/*@ requires 0 <= n && \valid(a+(0..n-1));
    assigns \nothing;
    ensures \result == -1 ==> (\forall integer i; 0<= i < n ==> a[i] != v);
    ensures 0 <= \result < n ==> a[\result] == v;
    ensures -1 <= \result < n;
 */
int find(int n, const int a[], int v)
{
  int i;

  /*@ loop invariant 0 <= i <= n;
      loop invariant \forall integer j; 0 <= j < i ==> a[j] != v;
      loop assigns i;
      loop variant n - i; */
  for (i=0; i < n; i++) {
    if (a[i] == v) {
      return i;
    }
  }

  return -1;
}
